package daemon

import (
	"context"

	"github.com/open-io/oio-exporter/common"
)

var TestFactory = &testDaemonFactory{}

type testDaemonFactory struct{}

func (df *testDaemonFactory) Daemons(inventory *common.Inventory) map[string]interface{} {
	params := make(map[string]interface{})

	for _, services := range inventory.Services {
		for _, service := range services {
			params[service.ID] = &testDaemonParams{
				id: service.ID,
			}
		}
	}

	return params
}

func (df *testDaemonFactory) New(paramsI interface{}) DaemonI {
	params := paramsI.(*testDaemonParams)

	return &testDaemon{
		id: params.id,
	}
}

type testDaemonParams struct {
	id string
}

type testDaemon struct {
	BaseDaemon

	id string
}

func (d *testDaemon) Collect(ctx context.Context, metrics *common.MetricData) error {
	return nil
}
